/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package adatkezeles;

import alaposztalyok.AlkoholosItal;
import alaposztalyok.Ital;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import javax.swing.DefaultListModel;

/**
 *
 * @author :) 
 */
public class FajlbolInput implements AdatInput {

    private String italEleres;
    private final String CHAR_SET = "UTF-8";    

    public FajlbolInput(String italEleres) {
        this.italEleres = italEleres;
    }
    
    @Override
    public List<Ital> italLista() throws Exception {
        // lehet úgy is, hogy üresen - vagy a figyelmeztető üzenettel hagyjuk
        // valamelyik metódust
        List<Ital> italok = new ArrayList<>();
        // mivel az inputstream is és a scanner is lezárandó objektum, ezért
        // érdemes a try fejében megnyitni, ekkor automatikus a lezárás
        try (
                InputStream ins = this.getClass().getResourceAsStream(italEleres);
                Scanner fajlScanner = new Scanner(ins, CHAR_SET)){
 
            String sor;
            String[] adatok;
            Ital ital = null;
            while (fajlScanner.hasNextLine()) {
                sor = fajlScanner.nextLine();
                adatok = sor.split(";");
                if (!sor.isEmpty()) {
                    adatok = sor.split(";");
                    if (adatok.length == 3) {
                        ital = new Ital(adatok[0], adatok[1],
                                Integer.parseInt(adatok[2]));
                    }
                    if (adatok.length == 5) {
                        ital = new AlkoholosItal(adatok[0], adatok[1],
                                Integer.parseInt(adatok[2]),
                                adatok[3], Double.parseDouble(adatok[4]));
                    }
                }
                italok.add(ital);
            }
        }
        return italok;
    }

    @Override
    public DefaultListModel<Ital> italModell() throws Exception {
        // lehet úgy is, hogy üresen - vagy a figyelmeztető üzenettel hagyjuk
        // valamelyik metódust
        DefaultListModel<Ital> italModel = new DefaultListModel<>();
        List<Ital> templist = italLista();
        for (Ital ital : templist) {
            italModel.addElement(ital);
        }
        return  italModel;
    }    
}
